/* ---------------------------------------------------------- */
/*  PanelManage.h                                             */
/* ---------------------------------------------------------- */

/*------------------------------------------------------------- */
/** @file
    @brief		XRApl̎NX
    @author		K.Kunikane (끗ӂ)
    @since		Feb.13.2005
    $Revision: 1.1.1.1 $
*/
/*-----------------------------------------------------
 Copyright (C) 2005 rero2@fumi <rero2@yuumu.org>
 All Rights Reserved.
 ------------------------------------------------------*/

#ifndef PANELMANAGE_H
#define PANELMANAGE_H

/*-------------------------------*/
/* include                       */
/*-------------------------------*/

#include "lunavader.h"
#include "basicsystem.h"
#include "spriteitem.h"

/*-------------------------------*/
/* define                        */
/*-------------------------------*/

/* --- ʏł̃plʒu */
#define PANELPOSX  448
#define PANELPOSY  0

/* --- Score ̈ʒu */
#define PANELSCOREX  32
#define PANELSCOREY  64

/* --- HiScore ̈ʒu */
#define PANELHISCOREX  32
#define PANELHISCOREY  (64 + 60)

/* --- Graze ̈ʒu */
#define PANELGRAZEX  32
#define PANELGRAZEY  (64 + 60 + 60)

/* --- Stage ̈ʒu */
#define PANELSTAGEX  32
#define PANELSTAGEY  (64 + 60 + 60 + 60)

/*-------------------------------*/
/* struct                        */
/*-------------------------------*/

/*-------------------------------*/
/* class                         */
/*-------------------------------*/

/**
 * @brief XRApl̕\Ǘ
 *        XRA̕\Ƃ̎
 *
 * @todo -
 * @bug -
 */
class PanelManage
{
  /* ----------------------------------- */
  /* --- RXgN^EfXgN^ */
 public:
  PanelManage();
  virtual  ~PanelManage();

  /* ----------------------------------- */
  /* --- pubNo */
 public:

  /* ----------------------------------- */
  /* --- vCx[go */
 private:
  LSPRITE  m_LunaSprite;
  //! XvCgIuWFNg
  SpriteItem  m_PanelSprite[BS_SPBUF_PANEL];
  int  m_Score;
  int  m_HighScore;
  int  m_Graze;
  int  m_Stage;
  int  m_Timer;
  bool m_GameOver;

  /* ----------------------------------- */
  /* --- pubN\bh */
 public:
  void  SetLunaSprite(LSPRITE sp_handle);
  bool  Tick();
  void  Display();
  void  SetScore(int score);
  void  SetHighScore(int hiscore);
  void  SetGraze(int graze);
  void  SetStage(int stage);
  void  SetGameOver(bool gameover);

  /* ----------------------------------- */
  /* --- vCx[g\bh */
 private:
  void  dec_display(int num,
		    int size,
		    int sprite,
		    int x,
		    int y);
  void  dec_display_fill(int num,
			 int size,
			 int sprite,
			 int x,
			 int y);

};


#endif

